      SUBROUTINE IAM1D(N,X0,X,Y,Z,II,F0)                                IAM10010
         INTEGER II,N                                                   IAM10020
         DOUBLE PRECISION F0,X,X0,Y,Z                                   IAM10030
         DIMENSION F0(N),II(N),X(N),Y(N),Z(N)                           IAM10040
         INTEGER I,I0,I1,I2,J,NN,NN1                                    IAM10050
         DOUBLE PRECISION R,R1,R2                                       IAM10060
       F0(1) = Y(1)*(X(1) - X0)                                         IAM10070
       DO 10 I = 2, N                                                   IAM10080
          F0(I) = F0(I-1) + Y(I)*(X(I) - X(I-1))                        IAM10090
   10  CONTINUE                                                         IAM10100
       II(1) = 1                                                        IAM10110
       NN = 1                                                           IAM10120
   20  CONTINUE                                                         IAM10130
       IF (II(NN) .EQ. N) GO TO 70                                      IAM10140
          II(NN+1) = II(NN) + 1                                         IAM10150
          NN = NN + 1                                                   IAM10160
   30  CONTINUE                                                         IAM10170
       IF (NN - 2) 20, 40, 50                                           IAM10180
   40  CONTINUE                                                         IAM10190
       I1 = II(1)                                                       IAM10200
       I2 = II(2)                                                       IAM10210
       IF (F0(I2)*(X(I1) - X0) - F0(I1)*(X(I2) - X0)) 60, 20, 20        IAM10220
   50  CONTINUE                                                         IAM10230
       I0 = II(NN-2)                                                    IAM10240
       I1 = II(NN-1)                                                    IAM10250
       I2 = II(NN)                                                      IAM10260
       R1 = (F0(I2) - F0(I1))*(X(I1) - X(I0))                           IAM10270
       R2 = (X(I2) - X(I1))*(F0(I1) - F0(I0))                           IAM10280
       IF (R1 .GE. R2) GO TO 20                                         IAM10290
   60  CONTINUE                                                         IAM10300
       II(NN-1) = II(NN)                                                IAM10310
       NN = NN - 1                                                      IAM10320
       GO TO 20                                                         IAM10330
   70  CONTINUE                                                         IAM10340
       IF (NN .EQ. 1) GO TO 100                                         IAM10350
          DO 90 J = 2, NN                                               IAM10360
             I1 = II(J-1)                                               IAM10370
             I2 = II(J)                                                 IAM10380
             R = (F0(I2) - F0(I1))/(X(I2) - X(I1))                      IAM10390
             I1 = I1 + 1                                                IAM10400
             DO 80 I = I1, I2                                           IAM10410
                Z(I) = R                                                IAM10420
   80        CONTINUE                                                   IAM10430
   90     CONTINUE                                                      IAM10440
  100  CONTINUE                                                         IAM10450
       I1 = II(1)                                                       IAM10460
       R = F0(I1)/(X(I1) - X0)                                          IAM10470
       DO 110 I = 1, I1                                                 IAM10480
          Z(I) = R                                                      IAM10490
  110  CONTINUE                                                         IAM10500
       IF (NN .EQ. N) GO TO 130                                         IAM10510
          NN1 = NN + 1                                                  IAM10520
          DO 120 I = NN1, N                                             IAM10530
             II(I) = 0                                                  IAM10540
  120     CONTINUE                                                      IAM10550
  130  CONTINUE                                                         IAM10560
       RETURN                                                           IAM10570
      END                                                               IAM10580
